//
//  (C)2013 Mobiq, Inc.
//

#import "Global.h"
#import "SDeployMonitor.h"

@interface SDeployMonitor()
- (void)startRequest;
@end

@implementation SDeployMonitor

- (id)initWithObject:(id)object delegate:(id)delegate {
    self = [super init];
    if (self) {
        _statusString = @"";
        _object = object;
        _delegate = delegate;
        _result = SDeployResultUnknown;
        [self startRequest];
    }
    return self;
}

- (void)startRequest {
    NSLog(@"startRequest...");
    _request = [[SRequest alloc] initWithToken:token
                                        apiPath:[NSString stringWithFormat:@"applications/%@/deployments/%@", _object[@"application_id"], _object[@"id"]]
                                       delegate:self];
    [_request start];
}

- (void)requestDidFinish:(SRequest *)request {
    NSLog(@"requestDidFinish request.json : %@", request.json);
    if ([request.json isKindOfClass:[NSDictionary class]]) {
        NSString *status = (request.json)[@"status"];
        NSLog(@"status : %@", status);
        if ([status isEqualToString:@"running"]) {
            [self startRequest];
            return;
        }

        _statusString = status;
        _result = SDeployResultUnknown;
        if([status isEqualToString:@"successful"]) _result = SDeployResultSuccessful;
        if([status isEqualToString:@"failed"]) _result = SDeployResultFailed;
        
        if ([_delegate respondsToSelector:@selector(deployDidFinish:)]) {
            [_delegate deployDidFinish:self];
        }            

    }
}

- (void)request:(SRequest *)request didFailWithError:(NSError *)error {

    _result = SDeployResultUnknown;
    if ([_delegate respondsToSelector:@selector(deployDidFinish:)]) {
        [_delegate deployDidFinish:self];
    }
}

@end
