//
//  (C)2013 Mobiq, Inc.
//

@class SRequest;

@protocol SRequestDelegate<NSObject>
@optional
- (void)requestDidFinish:(SRequest *)request;
- (void)request:(SRequest *)request didFailWithError:(NSError *)error;
@end


@interface SRequest : NSObject<NSURLConnectionDelegate> {
    NSURLConnection *_connection;
    NSMutableData *_buffer;
}

@property (copy) NSString *token;
@property (copy) NSString *apiPath;
@property (strong) id data;
@property (unsafe_unretained) id delegate;
@property (strong) id json;
@property (assign) NSUInteger tag;

- (id)initWithToken:(NSString *)token apiPath:(NSString *)apiPath delegate:(id)delegate;
- (void)start;
- (void)cancel;

@end
